(* File generated from fpp.idl *)

type internal

(*
 This file is part of the APRON Library, released under LGPL license.
 Please read the COPYING file packaged in the distribution.
*)

 
type t
(** Type of fppols.

Fppols are defined by conjunctions of inequalities of the form
[+/-x_i +/- x_j >= 0].

Abstract values which are fppols have the type [t Apron.AbstractX.t].

Managers allocated for fppols have the type [t Apron.manager.t].
*)

 
external manager_alloc : unit -> t Apron.Manager.t
	= "camlidl_fpp_fpp_manager_alloc"

external manager_get_internal : t Apron.Manager.t -> internal
	= "camlidl_fpp_manager_get_internal"

external of_generator_array : t Apron.Manager.t -> int -> int -> Apron.Generator0.t array -> t Apron.Abstract0.t
	= "camlidl_fpp_ap_abstract0_fpp_of_generator_array"

external widening_thresholds : t Apron.Manager.t -> t Apron.Abstract0.t -> t Apron.Abstract0.t -> Apron.Scalar.t array -> t Apron.Abstract0.t
	= "camlidl_fpp_ap_abstract0_fpp_widening_thresholds"

external narrowing : t Apron.Manager.t -> t Apron.Abstract0.t -> t Apron.Abstract0.t -> t Apron.Abstract0.t
	= "camlidl_fpp_ap_abstract0_fpp_narrowing"

external add_epsilon : t Apron.Manager.t -> t Apron.Abstract0.t -> Apron.Scalar.t -> t Apron.Abstract0.t
	= "camlidl_fpp_ap_abstract0_fpp_add_epsilon"

external add_epsilon_bin : t Apron.Manager.t -> t Apron.Abstract0.t -> t Apron.Abstract0.t -> Apron.Scalar.t -> t Apron.Abstract0.t
	= "camlidl_fpp_ap_abstract0_fpp_add_epsilon_bin"

let pre_widening = 99


let manager_is_fpp man =
  let str = Apron.Manager.get_library man in
  (String.compare str "fpp")==0
let manager_of_fpp (man:t Apron.Manager.t) : 'a Apron.Manager.t = Obj.magic man
let manager_to_fpp (man:'a Apron.Manager.t) : t Apron.Manager.t =
  if manager_is_fpp man then
    Obj.magic man
  else
    failwith "Fpp.manager_to_fpp: the argument manager is not a Fpp manager"
module Abstract0 = struct
  let is_fpp abs =
    manager_is_fpp (Apron.Abstract0.manager abs)
  let of_fpp (abs: t Apron.Abstract0.t) : 'a Apron.Abstract0.t = Obj.magic abs
  let to_fpp (abs:'a Apron.Abstract0.t) : t Apron.Abstract0.t =
  if is_fpp abs then
    Obj.magic abs
  else
    failwith "Fpp.Abstract0.to_fpp: the argument value is not a fpp value"
end
module Abstract1 = struct
  let is_fpp abs =
    manager_is_fpp (Apron.Abstract1.manager abs)
  let of_fpp (abs: t Apron.Abstract1.t) : 'a Apron.Abstract1.t = Obj.magic abs
  let to_fpp (abs:'a Apron.Abstract1.t) : t Apron.Abstract1.t =
  if is_fpp abs then
    Obj.magic abs
  else
    failwith "Fpp.Abstract1.to_fpp: the argument value is not a fpp value"
end

